	device zxspectrum128
        ORG #6000
begin
;runi:
 ld hl, ppic,de,$4000:call dzx7_standard

		ld a,$10,bc,$7FFD:out (c),a

		call	MoonSound_mwmload

		ld	hl,0C000h
		ld	(MBPlayer_songdata_addres),hl

		call	MBPlayer_init


xx:ei:halt
; ld a,1:out ($FE),a
cv2:ld a,0:inc a:ld (cv2+1),a
 and 1:jr nz,skippy
cv1: ld a,0:inc a
 cp 30:jr nz,no_loop
 xor a
no_loop:
 ld (cv1+1),a
skippy:
 ld a,(cv1+1)
 ld l,a,h,0
 ld de,hl
 add hl,hl
 add hl,de
 ld de,framet
 add hl,de
 ld a,(hl):inc hl
 ld bc,$7FFD:out (c),a
 ld a,(hl):inc hl:ld h,(hl),l,a
 ld (cp+1),hl
cp:call $82
; ld a,0:out ($FE),a
 call scroll
; ld a,4:out ($FE),a

 ld a,$10,bc,$7FFD:out (c),a
 push iy
 call MBPlayer_play
 pop iy
; ld a,7:out ($FE),a

 jp xx
;-----------------------------------------
screen_adr equ #401f;screen adress for output
scroll:
 ld hl,screen_adr
 ld b,8
scroll_text:
 push hl
 xor a

 dup 16;unroll cycle
 rl(hl)
 dec l
edup

 pop hl
 inc h
 dec b
 jp nz,scroll_text

;out text, IX: string with limiter 0
scrp:ld ix,scrtxt
 ld a,(ix)
 or a
 jr nz,noloop
;if zero loop text again
 ld ix,scrtxt
 ld a,(ix)
noloop:ld (scrp+2),ix

 ld de,screen_adr
 ld l,a,h,0; calculate adress ROM font
 
 add hl,hl;ascii*8
 add hl,hl
 add hl,hl
 ld bc,$3C00;ROM font
 add hl,bc
 ex de,hl


 ld b,8;one loop for letter
letrlp:
 ld a,(de)
bw:and #80
 jr nz,nobit
 set 0,(hl)
nobit:
 inc de,h
 djnz letrlp

 ld a,(bw+1)
 or a
 rrca
 ld (bw+1),a
 ret nc

 ld hl,(scrp+2)
 inc hl
 ld (scrp+2),hl
 ret
scrtxt: db "          Whoaaaaa! it is g0blinish typing..."
 db "n-joy da tune Frikandel special __ (C) Meits 1995, mfm player by Mick "
 db "is it deLyra II part remake? :3 "
 db "greets flying to TS-Labs, Mick, fuckings to psndcj and AAA, Rindex "
 db "and all #mhm jerks. so, it is over now, (c)g0blinish, 02.03.2016   "
 db 0

ppic:incbin"IMG00001.scr.zx7"
zx7:include "zx7.a80"

;-----------------------------------------
framet:
 db $11
 dw f0
 db $11
 dw f1
 db $11
 dw f2
 db $11
 dw f3
 db $11
 dw f4
 db $11
 dw f5
 db $11
 dw f6
 db $11
 dw f7

 db $13
 dw f8
 db $13
 dw f9
 db $13
 dw f10
 db $13
 dw f11
 db $13
 dw f12
 db $13
 dw f13
 db $13
 dw f14
 db $13
 dw f15
 db $13
 dw f16

 db $14
 dw f17
 db $14
 dw f18
 db $14
 dw f19
 db $14
 dw f20
 db $14
 dw f21
 db $14
 dw f22
 db $14
 dw f23
 db $14
 dw f24
 db $14
 dw f25

 db $16
 dw f26
 db $16
 dw f27
 db $16
 dw f28
 db $16
 dw f29
 
;-----------------------------------------
 include  "mfm_player.asm"

;-----------------------------------------
MoonSound_mwmload:
		ld	hl,0C000h
		ld	(load_position),hl
		ld	hl,0C000h
		ld	(MBPlayer_songdata_addres),hl

;--- Load MWM file ---

; Note: The routine below is a bit complex because it supports
; songs > 16K. However, if you know that your song will always be < 16K you
; can simplify it a lot:
; - read the header and trash it!
; - read the rest of the file
; - modify the play_nextpos routine so that 3 is added to the pattern address

mbload:

		ld	hl,MBPlayer_songdata_bank1	; select first song bank
		ld	(load_bank),hl
		ld	a,(hl)

		ld	hl,6
		ld	de,(MBPlayer_songdata_addres)
		call	load_file			; read header

		ld	hl,812
		ld	de,(MBPlayer_songdata_addres)		; read settings
		call	load_file
		ld	a,(de)
		add	hl,de
		ex	de,hl
		inc	a
		ld	l,a
		ld	h,0
		call	load_file			; read positions
		call	check_pats
		add	hl,de
		ex	de,hl
		add	a,a
		ld	l,a
		ld	h,0
		call	load_file			; read pattern addresses
		add	hl,de
		ld	(load_adres),hl

mbload_lp:
		ld	de,load_buffer
		ld	hl,3
		call	load_file
		ld	a,(load_buffer + 2)
		or	a
		ret	z
		ld	de,(load_adres)
		ld	hl,(load_buffer)
		call	load_file

		ld	de,0C000h
		ld	(load_adres),de
		ld	hl,(load_bank)
		inc	hl
		ld	a,(hl)
		ld	(load_bank),hl
		jr	mbload_lp



;--- Load (part of) file ---
; In: HL = number of bytes to read
;     DE = transfer address

load_file:	
		push	hl
		push	de
		push	bc

		push	hl
		pop	bc
		ld	hl,(load_position)
		ldir
		ld	(load_position),hl
		pop	bc
		pop	de
		pop	hl
		ret

;--- search highest pattern ---
; In: L = #positions, DE = pointer to patterns
; Out: A = highest pattern

check_pats:	
		push	hl
		push	de
		ld	b,l
		ex	de,hl
		xor	a
check_patslp:	
		cp	(hl)
		jr	nc,check_pats2
		ld	a,(hl)
check_pats2:	inc	hl
		djnz	check_patslp
		inc	a
		pop	de
		pop	hl
		ret

MoonSound_key_press:
		db	0
MoonSound_count_music:
		db	0
MoonSound_page_memory:
		db	0		

MoonSound_copy_addr:
		dw	0
MoonSound_copy_buffer:
		ds	256

load_adres:	dw	0
load_bank:	dw	0
load_position:	dw	0
load_buffer:	db	0,0,0

end

 page 0
 org $C000
page0b:
 incbin "Aleste-1.mfm"
page0e:
 
 page 1
 org $C000
page1b:
f0:incbin"frames\0.bin"
f1:incbin"frames\1.bin"
f2:incbin"frames\2.bin"
f3:incbin"frames\3.bin"
f4:incbin"frames\4.bin"
f5:incbin"frames\5.bin"
f6:incbin"frames\6.bin"
f7:incbin"frames\7.bin"
page1e:

 page 3
 org $C000
 
page3b:
f8:incbin"frames\8.bin"
f9:incbin"frames\9.bin"
f10:incbin"frames\10.bin"
f11:incbin"frames\11.bin"
f12:incbin"frames\12.bin"
f13:incbin"frames\13.bin"
f14:incbin"frames\14.bin"
f15:incbin"frames\15.bin"
f16:incbin"frames\16.bin"
page3e:

 page 4
 org $C000

page4b:
f17:incbin"frames\17.bin"
f18:incbin"frames\18.bin"
f19:incbin"frames\19.bin"
f20:incbin"frames\20.bin"
f21:incbin"frames\21.bin"
f22:incbin"frames\22.bin"
f23:incbin"frames\23.bin"
f24:incbin"frames\24.bin"
f25:incbin"frames\25.bin"
page4e:

 page 6
 org $C000

page6b:
f26:incbin"frames\26.bin"
f27:incbin"frames\27.bin"
f28:incbin"frames\28.bin"
f29:incbin"frames\29.bin"
page6e:
	display /d,end-begin
	savesna "!mfmplay.sna",begin
;---------------------------------------------------------------------------------
 macro	sectors datab,datae

 IF low (datae-datab)=0
   db 1,5,high (datae-datab)
 ELSE
   db 1,5,(1+high (datae-datab))
 ENDIF

	endm

 MODULE boot
Basic:
 db #00,#01; 
 DW EndLine1 - Line1
Line1:
 db #EA;REM
 ld sp,#5FE0

 xor a:out ($FE),a
 ld hl,$5AFF,de,$5AFE,bc,6912,(hl),0:lddr
;----------------------------demo------------
 di
;demo
;; ld a,#10,bc,#7FFD:out (c),a
 ld de,(#5CF4)
 ld hl, #6000
 sectors begin,end
 call #3d13

;p1
 ld a,#11,bc,#7FFD:out (c),a
 ld de,(#5CF4)
 ld hl, #C000
 sectors page1b,page1e
 call #3d13

;p3
 ld a,#13,bc,#7FFD:out (c),a
 ld de,(#5CF4)
 ld hl, #C000
 sectors page3b,page3e
 call #3d13

;p4
 ld a,#14,bc,#7FFD:out (c),a
 ld de,(#5CF4)
 ld hl, #C000
 sectors page4b,page4e
 call #3d13

;p6
 ld a,#16,bc,#7FFD:out (c),a
 ld de,(#5CF4)
 ld hl, #C000
 sectors page6b,page6e
 call #3d13

;p7
; ld a,#17,bc,#7FFD:out (c),a
; ld de,(#5CF4)
; ld hl, #C000
; sectors page7b,page7e
; call #3d13

;p0
 ld a,#10,bc,#7FFD:out (c),a
 ld de,(#5CF4)
 ld hl, #C000
 sectors page0b,page0e
 call #3d13

 jp $6000

 db "fuckings to Low Voltage Dildo & AloneFapper"
 db #0D
EndLine1:
 db #00,#02
 DW EndLine2 - Line2
Line2:
 db #20,#FD,#B0
 db #22,#32,#34,#35,#37,#35,#22;clear val "24575"
 db #3A; :
 db #F9,#C0,#28,#35;randomize usr (5+256*peek val "23635"+peek val "23636"
 db #0E,#00,#00,#05,#00,#00,#2B
 db #32,#35,#36
 db #0E,#00,#00,#00,#01,#00,#2A,#BE

 db #B0
 db #22,#32,#33,#36,#33,#36,#22;"23635"
 db #2B;???
 db #BE
 db #B0
 db #22,#32,#33,#36,#33,#35,#22;"23636"
 db #29,#0D;)
 db #80
 db #AA,1,0;;;;;;;;;;;;;autorun line,change program length to -4, e.g. 83-4=79
EndLine2:
EndBasic:
 ENDMODULE

    EMPTYTRD "verita.trd" ;create empty TRD image
	SAVETRD "verita.trd", "boot.B", boot.Basic, boot.EndBasic - boot.Basic

    SAVETRD "verita.trd","demo.C",begin,end-begin

    PAGE 1
    SAVETRD "verita.trd","pg1.C",page1b,page1e-page1b

    PAGE 3
    SAVETRD "verita.trd","pg3.C",page3b,page3e-page3b

    PAGE 4
    SAVETRD "verita.trd","pg4.C",page4b,page4e-page4b

    PAGE 6
    SAVETRD "verita.trd","pg6.C",page6b,page6e-page6b

;    PAGE 7
;    SAVETRD "verita.trd","pg7.C",page7b,page7e-page7b


    PAGE 0
    SAVETRD "verita.trd","pg0.C",page0b,page0e-page0b

;---------------------------------------------------------------------------------
